//---------------------------------------------------------------------------
#ifndef DSoundEngineH
#define DSoundEngineH

#include <mmsystem.h>
#include <dsound.h>
#include "Sound.h"

class DirectSoundEngine: public SoundEngine
{
protected:
    struct
    {
        int type;
        LPDIRECTSOUNDBUFFER buf;
        int pri;
        unsigned long start;
    } ch[SOUND_CHANNELS];
    int init;
    int soundMute;
    LPDIRECTSOUND lpDS;
public:
    DirectSoundEngine(HWND hWnd);
    ~DirectSoundEngine();
    int Initialized();
    void SetChannelType(int c,int t);
    int PlaySound(Sound *snd,int t,int pri,int loop);
    void StopSound(int c);
    void SoundMute(int mute);
};

//---------------------------------------------------------------------------
#endif
