//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
USERES("DukeEdit.res");
USEFORM("Edit.cpp", EditWnd);
USEUNIT("View.cpp");
USEUNIT("D3DRender.cpp");
USEUNIT("Direct3d.cpp");
USEUNIT("DirectDraw.cpp");
USEUNIT("DSoundEngine.cpp");
USEUNIT("FixPoly.cpp");
USEUNIT("GroupFile.cpp");
USEUNIT("map.cpp");
USEUNIT("Math3d.cpp");
USEUNIT("music.cpp");
USEUNIT("OpenGLRender.cpp");
USEUNIT("poly.cpp");
USEUNIT("Render.cpp");
USEUNIT("SoftRender.cpp");
USEUNIT("Sound.cpp");
USEUNIT("Texture.cpp");
USEUNIT("Vertex.cpp");
USEUNIT("art.cpp");
USEUNIT("console.cpp");
USELIB("..\..\Lib\dxguid.lib");
USEFORM("TexView.cpp", TextureViewWnd);
//---------------------------------------------------------------------------
HINSTANCE hInst;
//---------------------------------------------------------------------------
WINAPI WinMain(HINSTANCE _hInst, HINSTANCE, LPSTR, int)
{
    hInst=_hInst;
    try
    {
         Application->Initialize();
         Application->Title = "Duke Nukem 3D Editor";
         Application->CreateForm(__classid(TEditWnd), &EditWnd);
         Application->CreateForm(__classid(TTextureViewWnd), &TextureViewWnd);
         Application->Run();
    }
    catch (Exception &exception)
    {
         Application->ShowException(&exception);
    }
    return 0;
}
//---------------------------------------------------------------------------
